#rules for asm80 .asm and m4 preprocessed .Asm
#$Id: m100rules.mk,v 1.14 2022/01/05 05:07:31 goosey Exp goosey $

#do not delete hex files just because they're intermediates
.PRECIOUS: %.hex

%.hex: %.asm
	asm80 -l $<
#asm80 prints topmost address when finished
	@echo M100 MAXRAM = F5EF
	@echo M200 MAXRAM = EEB0

	todos < $@ > $@.dos
	rm $@
	mv $@.dos $@

%.asm: %.Asm
	m4 ${M4OPTS} $< > $@	

%.hex: %.zm
	zmac -h -z -m $<
	todos < $@ > $@.dos
	rm $@
	mv $@.dos $@

%.co: %.hex
	hex2co $<

#REX rom image
%.bx: %.hex
	objcopy -I ihex -O binary --pad-to 32768 $< $@ 

#WP-2 from zmac
%.bin: %.zm
	zmac -m $<

%.cmd: %.bin
	mv $< $@


